#include <iostream>
#include <fstream>
using namespace std;

int fileSize(FILE *pFile)
{
	int sz = 0;
	//	If the file pointer is NULL, return -1
	if(pFile == NULL)
		return -1;
	fseek(pFile, 0, SEEK_SET); // Set the cursor to the beggining of the file
	fseek(pFile, 0, SEEK_END); // Now set it to the end of the file ***
	//	The offsets are NULLED

	//	Get the location of the caret
	sz = ftell(pFile); // See "***"
	rewind(pFile); //	Reset the cursor position
	return sz; //	Return the size
};

int main(int argc, char *argv[])
{
	cout << "***************************************************" << endl;
	cout << "* Simple bootsector writer for virtual disk files *" << endl;
	cout << "* Cristian @ OSDev forums // July 2010 // Enjoy!  *" << endl;
	cout << "***************************************************" << endl;
	char *what = argv[1]; // Holds the first argument
	char *where = argv[2]; // Holds the seconds argument

	if(!what){
		cout << "[USAGE]: wbootinfo [kernel/boot loader] [diskimage]" << endl;
	} else {
		if(!where){
				cout << "[USAGE]: wbootinfo [kernel/boot loader] [diskimage]" << endl;
		} else {
			cout << "Writing " << what << " to " << where << ": ";
			FILE *pWhat = fopen(what, "rb");
			FILE *pWhere = fopen(where, "ab");
			//Copy the content of the what into a buffer
			int iWhat = fileSize(pWhat);
			char *buffwhat = new char[iWhat + (512 - iWhat)];
			memset(buffwhat, 0, iWhat + (512 - iWhat));
			fread(buffwhat, 1, iWhat, pWhat);
			fclose(pWhat);
			//Copy the content of the where file into a buffer
			int iWhere = fileSize(pWhere);
			char *buffwhere = new char[iWhere];
			memset(buffwhere, 0, iWhere);
			memcpy(buffwhere, buffwhat, 512);
			fclose(pWhere);
			free(buffwhat);

			//save the changes
			FILE *tmp = fopen(where, "wb");
			fwrite(buffwhere, 1, iWhere, tmp);
			fclose(tmp);
			free(buffwhere);

			cout << "Done." << endl;
		}
	}

	getchar();
	return 1;
}